package mi.hdm.controllers.components;

import javafx.fxml.FXML;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import mi.hdm.GUIDriver;
import mi.hdm.controllers.BaseController;
import mi.hdm.controllers.View;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class HeaderController extends BaseController {
    private final static Logger log = LogManager.getLogger(HeaderController.class);

    @FXML
    private ImageView musicButtonImageView;

    private static final String PATH_TO_SOUND_ON = "/images/Tasty_Pages_sound_on.png";
    private static final String PATH_TO_SOUND_OFF = "/images/Tasty_Pages_sound_off.png";

    private boolean isMusicPlaying = true;


    @FXML
    public void initialize() {
        setCorrectMusicImage();
    }

    @FXML
    public void changeSceneToHome() {
        changeScene(View.MAIN);
    }

    @FXML
    public void changeSceneToShoppingList() {
        changeScene(View.SHOPPINGLIST_VIEW);
    }

    @FXML
    public void changeSceneToMealPlan() {
        changeScene(View.MEALPLAN_VIEW);
    }

    @FXML
    public void changeSceneToIngredientCreator() {
        changeScene(View.INGREDIENT_CREATOR);
    }

    public void changeSceneToCategoryCreator() {
        changeScene(View.CATEGORY_CREATOR);
    }

    @FXML
    public void handleMusicSetting() {
        log.debug("User toggled music button");
        isMusicPlaying = !isMusicPlaying;
        if (isMusicPlaying) {
            GUIDriver.getAppInstance().playMusic();
        } else {
            GUIDriver.getAppInstance().pauseMusic();
        }
        setCorrectMusicImage();
    }

    private void setCorrectMusicImage() {
        Image image;
        if (isMusicPlaying) {
            image = imageFromPath(PATH_TO_SOUND_ON);
        } else {
            image = imageFromPath(PATH_TO_SOUND_OFF);
        }
        musicButtonImageView.setImage(image);
    }

    private Image imageFromPath(String path) {
        return new Image(HeaderController.class.getResource(path).toString());
    }
}
